import { isUndefined } from 'lodash'
import { AnnotationTool } from 'substance'

class NoteTool extends AnnotationTool {
  renderButton ($$) {
    const el = super.renderButton($$)
    const readOnly = this.isSurfaceReadOnly()

    if (!isUndefined(readOnly)) el.attr('disabled', 'true')
    return el
  }

  getSurface () {
    const surfaceManager = this.context.surfaceManager
    const containerId = this.context.controller.props.containerId

    return surfaceManager.getSurface(containerId)
  }

  isSurfaceReadOnly () {
    const surface = this.getSurface()
    if (!surface) return

    return surface.isReadOnlyMode()
  }
}

NoteTool.type = 'note'

export default NoteTool
